/* StatusIcon.c generated by valac, the Vala compiler
 * generated from StatusIcon.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*- */
/*
    This file is part of Déjà Dup.
    © 2009 Michael Terry <mike@mterry.name>

    Déjà Dup is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Déjà Dup is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Déjà Dup.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <deja-dup.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <hacks.h>


#define TYPE_STATUS_ICON (status_icon_get_type ())
#define STATUS_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STATUS_ICON, StatusIcon))
#define STATUS_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STATUS_ICON, StatusIconClass))
#define IS_STATUS_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STATUS_ICON))
#define IS_STATUS_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STATUS_ICON))
#define STATUS_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STATUS_ICON, StatusIconClass))

typedef struct _StatusIcon StatusIcon;
typedef struct _StatusIconClass StatusIconClass;
typedef struct _StatusIconPrivate StatusIconPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _StatusIcon {
	GtkStatusIcon parent_instance;
	StatusIconPrivate * priv;
};

struct _StatusIconClass {
	GtkStatusIconClass parent_class;
};

struct _StatusIconPrivate {
	DejaDupOperation* _op;
	gboolean _automatic;
	char* action;
	double progress;
};


static gpointer status_icon_parent_class = NULL;

GType status_icon_get_type (void);
#define STATUS_ICON_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_STATUS_ICON, StatusIconPrivate))
enum  {
	STATUS_ICON_DUMMY_PROPERTY,
	STATUS_ICON_OP,
	STATUS_ICON_AUTOMATIC
};
static void status_icon_set_op (StatusIcon* self, DejaDupOperation* value);
static void status_icon_set_automatic (StatusIcon* self, gboolean value);
StatusIcon* status_icon_new (DejaDupOperation* op, gboolean automatic);
StatusIcon* status_icon_construct (GType object_type, DejaDupOperation* op, gboolean automatic);
static void status_icon_update_tooltip (StatusIcon* self);
static void status_icon_set_action_desc (StatusIcon* self, DejaDupOperation* op, const char* action);
static void status_icon_note_progress (StatusIcon* self, DejaDupOperation* op, double progress);
DejaDupOperation* status_icon_get_op (StatusIcon* self);
static void status_icon_later (StatusIcon* self);
static void status_icon_skip (StatusIcon* self);
static void _lambda0_ (GtkMenuItem* i, StatusIcon* self);
static void __lambda0__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
gboolean status_icon_get_automatic (StatusIcon* self);
static void _lambda1_ (GtkMenuItem* i, StatusIcon* self);
static void __lambda1__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void _gtk_status_icon_position_menu_gtk_menu_position_func (GtkMenu* menu, gint* x, gint* y, gboolean* push_in, gpointer self);
static void status_icon_show_menu (StatusIcon* self, GtkStatusIcon* status_icon, guint button, guint activate_time);
static void _status_icon_show_menu_gtk_status_icon_popup_menu (GtkStatusIcon* _sender, guint button, guint activate_time, gpointer self);
static void _lambda2_ (GtkStatusIcon* s, StatusIcon* self);
static void __lambda2__gtk_status_icon_activate (GtkStatusIcon* _sender, gpointer self);
static void _status_icon_set_action_desc_deja_dup_operation_action_desc_changed (DejaDupOperation* _sender, const char* action, gpointer self);
static void _status_icon_note_progress_deja_dup_operation_progress (DejaDupOperation* _sender, double percent, gpointer self);
static GObject * status_icon_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void status_icon_finalize (GObject* obj);
static void status_icon_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void status_icon_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);



StatusIcon* status_icon_construct (GType object_type, DejaDupOperation* op, gboolean automatic) {
	GParameter * __params;
	GParameter * __params_it;
	StatusIcon * self;
	g_return_val_if_fail (op != NULL, NULL);
	__params = g_new0 (GParameter, 2);
	__params_it = __params;
	__params_it->name = "op";
	g_value_init (&__params_it->value, DEJA_DUP_TYPE_OPERATION);
	g_value_set_object (&__params_it->value, op);
	__params_it++;
	__params_it->name = "automatic";
	g_value_init (&__params_it->value, G_TYPE_BOOLEAN);
	g_value_set_boolean (&__params_it->value, automatic);
	__params_it++;
	self = g_object_newv (object_type, __params_it - __params, __params);
	while (__params_it > __params) {
		--__params_it;
		g_value_unset (&__params_it->value);
	}
	g_free (__params);
	return self;
}


StatusIcon* status_icon_new (DejaDupOperation* op, gboolean automatic) {
	return status_icon_construct (TYPE_STATUS_ICON, op, automatic);
}


static void status_icon_set_action_desc (StatusIcon* self, DejaDupOperation* op, const char* action) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (op != NULL);
	g_return_if_fail (action != NULL);
	self->priv->action = (_tmp0_ = g_strdup (action), _g_free0 (self->priv->action), _tmp0_);
	status_icon_update_tooltip (self);
}


static void status_icon_note_progress (StatusIcon* self, DejaDupOperation* op, double progress) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (op != NULL);
	self->priv->progress = progress;
	status_icon_update_tooltip (self);
}


static void status_icon_update_tooltip (StatusIcon* self) {
	char* tooltip;
	g_return_if_fail (self != NULL);
	tooltip = g_strdup ("");
	if (self->priv->action != NULL) {
		char* _tmp0_;
		tooltip = (_tmp0_ = g_strdup (self->priv->action), _g_free0 (tooltip), _tmp0_);
	}
	if (self->priv->progress > 0) {
		char* _tmp3_;
		char* _tmp2_;
		char* _tmp1_;
		tooltip = (_tmp3_ = g_strconcat (_tmp1_ = g_strconcat (tooltip, "\n", NULL), _tmp2_ = g_strdup_printf (_ ("%.1f%% complete"), self->priv->progress * 100), NULL), _g_free0 (tooltip), _tmp3_);
		_g_free0 (_tmp2_);
		_g_free0 (_tmp1_);
	}
	hacks_status_icon_set_tooltip_text ((GtkStatusIcon*) self, tooltip);
	_g_free0 (tooltip);
}


static void status_icon_later (StatusIcon* self) {
	g_return_if_fail (self != NULL);
	g_signal_emit_by_name (self, "hide-all");
	deja_dup_operation_stop (self->priv->_op);
}


static void status_icon_skip (StatusIcon* self) {
	GError * _inner_error_;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	g_signal_emit_by_name (self, "hide-all");
	{
		deja_dup_update_last_run_timestamp (&_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch10_g_error;
			goto __finally10;
		}
	}
	goto __finally10;
	__catch10_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_warning ("StatusIcon.vala:89: %s\n", e->message);
			_g_error_free0 (e);
		}
	}
	__finally10:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
	deja_dup_operation_cancel (self->priv->_op);
}


static void _lambda0_ (GtkMenuItem* i, StatusIcon* self) {
	g_return_if_fail (i != NULL);
	status_icon_later (self);
}


static void __lambda0__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	_lambda0_ (_sender, self);
}


static void _lambda1_ (GtkMenuItem* i, StatusIcon* self) {
	g_return_if_fail (i != NULL);
	status_icon_skip (self);
}


static void __lambda1__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	_lambda1_ (_sender, self);
}


static void _gtk_status_icon_position_menu_gtk_menu_position_func (GtkMenu* menu, gint* x, gint* y, gboolean* push_in, gpointer self) {
	gtk_status_icon_position_menu (menu, x, y, push_in, self);
}


static void status_icon_show_menu (StatusIcon* self, GtkStatusIcon* status_icon, guint button, guint activate_time) {
	GtkMenu* menu;
	GtkMenuItem* item;
	DejaDupDuplicityInfo* _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (status_icon != NULL);
	menu = g_object_ref_sink ((GtkMenu*) gtk_menu_new ());
	item = NULL;
	if ((_tmp1_ = deja_dup_duplicity_info_get_can_resume (_tmp0_ = deja_dup_duplicity_info_get_default ()), _g_object_unref0 (_tmp0_), _tmp1_)) {
		GtkMenuItem* _tmp2_;
		item = (_tmp2_ = g_object_ref_sink ((GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_ ("_Resume Later"))), _g_object_unref0 (item), _tmp2_);
	} else {
		GtkMenuItem* _tmp3_;
		item = (_tmp3_ = g_object_ref_sink ((GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_ ("_Delay Backup"))), _g_object_unref0 (item), _tmp3_);
	}
	g_signal_connect_object (item, "activate", (GCallback) __lambda0__gtk_menu_item_activate, self, 0);
	gtk_menu_shell_append ((GtkMenuShell*) menu, (GtkWidget*) item);
	if (self->priv->_automatic) {
		GtkMenuItem* _tmp4_;
		item = (_tmp4_ = g_object_ref_sink ((GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_ ("_Skip Backup"))), _g_object_unref0 (item), _tmp4_);
		g_signal_connect_object (item, "activate", (GCallback) __lambda1__gtk_menu_item_activate, self, 0);
		gtk_menu_shell_append ((GtkMenuShell*) menu, (GtkWidget*) item);
	}
	gtk_widget_show_all ((GtkWidget*) menu);
	gtk_menu_popup (menu, NULL, NULL, _gtk_status_icon_position_menu_gtk_menu_position_func, (GtkStatusIcon*) self, button, (guint32) activate_time);
	_g_object_unref0 (menu);
	_g_object_unref0 (item);
}


DejaDupOperation* status_icon_get_op (StatusIcon* self) {
	DejaDupOperation* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_op;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void status_icon_set_op (StatusIcon* self, DejaDupOperation* value) {
	DejaDupOperation* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_op = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_op), _tmp0_);
	g_object_notify ((GObject *) self, "op");
}


gboolean status_icon_get_automatic (StatusIcon* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_automatic;
	return result;
}


static void status_icon_set_automatic (StatusIcon* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_automatic = value;
	g_object_notify ((GObject *) self, "automatic");
}


static void _status_icon_show_menu_gtk_status_icon_popup_menu (GtkStatusIcon* _sender, guint button, guint activate_time, gpointer self) {
	status_icon_show_menu (self, _sender, button, activate_time);
}


static void _lambda2_ (GtkStatusIcon* s, StatusIcon* self) {
	g_return_if_fail (s != NULL);
	g_signal_emit_by_name (self, "activated", (guint) 0);
}


static void __lambda2__gtk_status_icon_activate (GtkStatusIcon* _sender, gpointer self) {
	_lambda2_ (_sender, self);
}


static void _status_icon_set_action_desc_deja_dup_operation_action_desc_changed (DejaDupOperation* _sender, const char* action, gpointer self) {
	status_icon_set_action_desc (self, _sender, action);
}


static void _status_icon_note_progress_deja_dup_operation_progress (DejaDupOperation* _sender, double percent, gpointer self) {
	status_icon_note_progress (self, _sender, percent);
}


static GObject * status_icon_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	StatusIcon * self;
	parent_class = G_OBJECT_CLASS (status_icon_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = STATUS_ICON (obj);
	{
		g_object_set ((GtkStatusIcon*) self, "icon-name", "deja-dup-applet", NULL);
		g_object_set ((GObject*) self, "title", _ ("Déjà Dup"), NULL);
		if (deja_dup_operation_get_mode (self->priv->_op) == DEJA_DUP_OPERATION_MODE_BACKUP) {
			g_signal_connect_object ((GtkStatusIcon*) self, "popup-menu", (GCallback) _status_icon_show_menu_gtk_status_icon_popup_menu, self, 0);
		}
		g_signal_connect_object ((GtkStatusIcon*) self, "activate", (GCallback) __lambda2__gtk_status_icon_activate, self, 0);
		g_signal_connect_object (self->priv->_op, "action-desc-changed", (GCallback) _status_icon_set_action_desc_deja_dup_operation_action_desc_changed, self, 0);
		g_signal_connect_object (self->priv->_op, "progress", (GCallback) _status_icon_note_progress_deja_dup_operation_progress, self, 0);
	}
	return obj;
}


static void status_icon_class_init (StatusIconClass * klass) {
	status_icon_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (StatusIconPrivate));
	G_OBJECT_CLASS (klass)->get_property = status_icon_get_property;
	G_OBJECT_CLASS (klass)->set_property = status_icon_set_property;
	G_OBJECT_CLASS (klass)->constructor = status_icon_constructor;
	G_OBJECT_CLASS (klass)->finalize = status_icon_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), STATUS_ICON_OP, g_param_spec_object ("op", "op", "op", DEJA_DUP_TYPE_OPERATION, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), STATUS_ICON_AUTOMATIC, g_param_spec_boolean ("automatic", "automatic", "automatic", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_signal_new ("activated", TYPE_STATUS_ICON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__UINT, G_TYPE_NONE, 1, G_TYPE_UINT);
	g_signal_new ("hide_all", TYPE_STATUS_ICON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void status_icon_instance_init (StatusIcon * self) {
	self->priv = STATUS_ICON_GET_PRIVATE (self);
	self->priv->_automatic = FALSE;
}


static void status_icon_finalize (GObject* obj) {
	StatusIcon * self;
	self = STATUS_ICON (obj);
	_g_object_unref0 (self->priv->_op);
	_g_free0 (self->priv->action);
	G_OBJECT_CLASS (status_icon_parent_class)->finalize (obj);
}


GType status_icon_get_type (void) {
	static GType status_icon_type_id = 0;
	if (status_icon_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (StatusIconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) status_icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (StatusIcon), 0, (GInstanceInitFunc) status_icon_instance_init, NULL };
		status_icon_type_id = g_type_register_static (GTK_TYPE_STATUS_ICON, "StatusIcon", &g_define_type_info, 0);
	}
	return status_icon_type_id;
}


static void status_icon_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	StatusIcon * self;
	self = STATUS_ICON (object);
	switch (property_id) {
		case STATUS_ICON_OP:
		g_value_set_object (value, status_icon_get_op (self));
		break;
		case STATUS_ICON_AUTOMATIC:
		g_value_set_boolean (value, status_icon_get_automatic (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void status_icon_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	StatusIcon * self;
	self = STATUS_ICON (object);
	switch (property_id) {
		case STATUS_ICON_OP:
		status_icon_set_op (self, g_value_get_object (value));
		break;
		case STATUS_ICON_AUTOMATIC:
		status_icon_set_automatic (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}




