/* Backend.c generated by valac, the Vala compiler
 * generated from Backend.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*- */
/*
    This file is part of Déjà Dup.
    © 2008,2009 Michael Terry <mike@mterry.name>

    Déjà Dup is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Déjà Dup is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Déjà Dup.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <gconf/gconf-client.h>


#define DEJA_DUP_TYPE_BACKEND (deja_dup_backend_get_type ())
#define DEJA_DUP_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DEJA_DUP_TYPE_BACKEND, DejaDupBackend))
#define DEJA_DUP_BACKEND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DEJA_DUP_TYPE_BACKEND, DejaDupBackendClass))
#define DEJA_DUP_IS_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DEJA_DUP_TYPE_BACKEND))
#define DEJA_DUP_IS_BACKEND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DEJA_DUP_TYPE_BACKEND))
#define DEJA_DUP_BACKEND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DEJA_DUP_TYPE_BACKEND, DejaDupBackendClass))

typedef struct _DejaDupBackend DejaDupBackend;
typedef struct _DejaDupBackendClass DejaDupBackendClass;
typedef struct _DejaDupBackendPrivate DejaDupBackendPrivate;

#define DEJA_DUP_OPERATION_TYPE_MODE (deja_dup_operation_mode_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __g_list_free_g_free0(var) ((var == NULL) ? NULL : (var = (_g_list_free_g_free (var), NULL)))

#define DEJA_DUP_TYPE_BACKEND_S3 (deja_dup_backend_s3_get_type ())
#define DEJA_DUP_BACKEND_S3(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DEJA_DUP_TYPE_BACKEND_S3, DejaDupBackendS3))
#define DEJA_DUP_BACKEND_S3_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DEJA_DUP_TYPE_BACKEND_S3, DejaDupBackendS3Class))
#define DEJA_DUP_IS_BACKEND_S3(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DEJA_DUP_TYPE_BACKEND_S3))
#define DEJA_DUP_IS_BACKEND_S3_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DEJA_DUP_TYPE_BACKEND_S3))
#define DEJA_DUP_BACKEND_S3_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DEJA_DUP_TYPE_BACKEND_S3, DejaDupBackendS3Class))

typedef struct _DejaDupBackendS3 DejaDupBackendS3;
typedef struct _DejaDupBackendS3Class DejaDupBackendS3Class;
#define _g_free0(var) (var = (g_free (var), NULL))

#define DEJA_DUP_TYPE_BACKEND_FILE (deja_dup_backend_file_get_type ())
#define DEJA_DUP_BACKEND_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DEJA_DUP_TYPE_BACKEND_FILE, DejaDupBackendFile))
#define DEJA_DUP_BACKEND_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DEJA_DUP_TYPE_BACKEND_FILE, DejaDupBackendFileClass))
#define DEJA_DUP_IS_BACKEND_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DEJA_DUP_TYPE_BACKEND_FILE))
#define DEJA_DUP_IS_BACKEND_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DEJA_DUP_TYPE_BACKEND_FILE))
#define DEJA_DUP_BACKEND_FILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DEJA_DUP_TYPE_BACKEND_FILE, DejaDupBackendFileClass))

typedef struct _DejaDupBackendFile DejaDupBackendFile;
typedef struct _DejaDupBackendFileClass DejaDupBackendFileClass;

typedef enum  {
	DEJA_DUP_OPERATION_MODE_INVALID,
	DEJA_DUP_OPERATION_MODE_BACKUP,
	DEJA_DUP_OPERATION_MODE_RESTORE,
	DEJA_DUP_OPERATION_MODE_STATUS
} DejaDupOperationMode;

struct _DejaDupBackend {
	GObject parent_instance;
	DejaDupBackendPrivate * priv;
};

struct _DejaDupBackendClass {
	GObjectClass parent_class;
	gboolean (*is_native) (DejaDupBackend* self);
	char* (*get_location) (DejaDupBackend* self, GError** error);
	char* (*get_location_pretty) (DejaDupBackend* self, GError** error);
	void (*get_envp) (DejaDupBackend* self, GError** error);
	void (*add_argv) (DejaDupBackend* self, DejaDupOperationMode mode, GList** argv);
	DejaDupBackend* (*clone) (DejaDupBackend* self);
};

struct _DejaDupBackendPrivate {
	GMountOperation* _mount_op;
	GtkWindow* _toplevel;
};


static gpointer deja_dup_backend_parent_class = NULL;

GType deja_dup_backend_get_type (void);
GType deja_dup_operation_mode_get_type (void);
#define DEJA_DUP_BACKEND_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DEJA_DUP_TYPE_BACKEND, DejaDupBackendPrivate))
enum  {
	DEJA_DUP_BACKEND_DUMMY_PROPERTY,
	DEJA_DUP_BACKEND_MOUNT_OP,
	DEJA_DUP_BACKEND_TOPLEVEL
};
gboolean deja_dup_backend_is_native (DejaDupBackend* self);
static gboolean deja_dup_backend_real_is_native (DejaDupBackend* self);
char* deja_dup_backend_get_location (DejaDupBackend* self, GError** error);
static char* deja_dup_backend_real_get_location (DejaDupBackend* self, GError** error);
char* deja_dup_backend_get_location_pretty (DejaDupBackend* self, GError** error);
static char* deja_dup_backend_real_get_location_pretty (DejaDupBackend* self, GError** error);
static void _g_list_free_g_free (GList* self);
void deja_dup_backend_get_envp (DejaDupBackend* self, GError** error);
static void deja_dup_backend_real_get_envp (DejaDupBackend* self, GError** error);
void deja_dup_backend_add_argv (DejaDupBackend* self, DejaDupOperationMode mode, GList** argv);
static void deja_dup_backend_real_add_argv (DejaDupBackend* self, DejaDupOperationMode mode, GList** argv);
DejaDupBackend* deja_dup_backend_clone (DejaDupBackend* self);
static DejaDupBackend* deja_dup_backend_real_clone (DejaDupBackend* self);
GConfClient* deja_dup_get_gconf_client (void);
#define DEJA_DUP_BACKEND_KEY "/apps/deja-dup/backend"
DejaDupBackendS3* deja_dup_backend_s3_new (GtkWindow* win);
DejaDupBackendS3* deja_dup_backend_s3_construct (GType object_type, GtkWindow* win);
GType deja_dup_backend_s3_get_type (void);
DejaDupBackendFile* deja_dup_backend_file_new (GtkWindow* win);
DejaDupBackendFile* deja_dup_backend_file_construct (GType object_type, GtkWindow* win);
GType deja_dup_backend_file_get_type (void);
DejaDupBackend* deja_dup_backend_get_default (GtkWindow* win, GError** error);
DejaDupBackend* deja_dup_backend_construct (GType object_type);
GMountOperation* deja_dup_backend_get_mount_op (DejaDupBackend* self);
void deja_dup_backend_set_mount_op (DejaDupBackend* self, GMountOperation* value);
GtkWindow* deja_dup_backend_get_toplevel (DejaDupBackend* self);
static void deja_dup_backend_set_toplevel (DejaDupBackend* self, GtkWindow* value);
static void deja_dup_backend_finalize (GObject* obj);
static void deja_dup_backend_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void deja_dup_backend_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static int _vala_strcmp0 (const char * str1, const char * str2);


static void g_cclosure_user_marshal_VOID__BOOLEAN_POINTER_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);

static gboolean deja_dup_backend_real_is_native (DejaDupBackend* self) {
	g_return_val_if_fail (self != NULL, FALSE);
	g_critical ("Type `%s' does not implement abstract method `deja_dup_backend_is_native'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return FALSE;
}


gboolean deja_dup_backend_is_native (DejaDupBackend* self) {
	return DEJA_DUP_BACKEND_GET_CLASS (self)->is_native (self);
}


static char* deja_dup_backend_real_get_location (DejaDupBackend* self, GError** error) {
	g_return_val_if_fail (self != NULL, NULL);
	g_critical ("Type `%s' does not implement abstract method `deja_dup_backend_get_location'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


char* deja_dup_backend_get_location (DejaDupBackend* self, GError** error) {
	return DEJA_DUP_BACKEND_GET_CLASS (self)->get_location (self, error);
}


static char* deja_dup_backend_real_get_location_pretty (DejaDupBackend* self, GError** error) {
	g_return_val_if_fail (self != NULL, NULL);
	g_critical ("Type `%s' does not implement abstract method `deja_dup_backend_get_location_pretty'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


char* deja_dup_backend_get_location_pretty (DejaDupBackend* self, GError** error) {
	return DEJA_DUP_BACKEND_GET_CLASS (self)->get_location_pretty (self, error);
}


static void _g_list_free_g_free (GList* self) {
	g_list_foreach (self, (GFunc) g_free, NULL);
	g_list_free (self);
}


static void deja_dup_backend_real_get_envp (DejaDupBackend* self, GError** error) {
	GList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_signal_emit_by_name (self, "envp-ready", TRUE, _tmp0_ = NULL, NULL);
	__g_list_free_g_free0 (_tmp0_);
}


void deja_dup_backend_get_envp (DejaDupBackend* self, GError** error) {
	DEJA_DUP_BACKEND_GET_CLASS (self)->get_envp (self, error);
}


static void deja_dup_backend_real_add_argv (DejaDupBackend* self, DejaDupOperationMode mode, GList** argv) {
	g_return_if_fail (self != NULL);
}


void deja_dup_backend_add_argv (DejaDupBackend* self, DejaDupOperationMode mode, GList** argv) {
	DEJA_DUP_BACKEND_GET_CLASS (self)->add_argv (self, mode, argv);
}


static DejaDupBackend* deja_dup_backend_real_clone (DejaDupBackend* self) {
	g_return_val_if_fail (self != NULL, NULL);
	g_critical ("Type `%s' does not implement abstract method `deja_dup_backend_clone'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


DejaDupBackend* deja_dup_backend_clone (DejaDupBackend* self) {
	return DEJA_DUP_BACKEND_GET_CLASS (self)->clone (self);
}


DejaDupBackend* deja_dup_backend_get_default (GtkWindow* win, GError** error) {
	DejaDupBackend* result;
	GError * _inner_error_;
	GConfClient* client;
	char* backend_name;
	_inner_error_ = NULL;
	client = deja_dup_get_gconf_client ();
	backend_name = g_strdup (gconf_client_get_string (client, DEJA_DUP_BACKEND_KEY, &_inner_error_));
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (client);
		return NULL;
	}
	if (_vala_strcmp0 (backend_name, "s3") == 0) {
		result = (DejaDupBackend*) deja_dup_backend_s3_new (win);
		_g_object_unref0 (client);
		_g_free0 (backend_name);
		return result;
	} else {
		if (_vala_strcmp0 (backend_name, "file") == 0) {
			result = (DejaDupBackend*) deja_dup_backend_file_new (win);
			_g_object_unref0 (client);
			_g_free0 (backend_name);
			return result;
		} else {
			result = NULL;
			_g_object_unref0 (client);
			_g_free0 (backend_name);
			return result;
		}
	}
	_g_object_unref0 (client);
	_g_free0 (backend_name);
}


DejaDupBackend* deja_dup_backend_construct (GType object_type) {
	DejaDupBackend * self;
	self = (DejaDupBackend*) g_object_new (object_type, NULL);
	return self;
}


GMountOperation* deja_dup_backend_get_mount_op (DejaDupBackend* self) {
	GMountOperation* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_mount_op;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void deja_dup_backend_set_mount_op (DejaDupBackend* self, GMountOperation* value) {
	GMountOperation* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_mount_op = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_mount_op), _tmp0_);
	g_object_notify ((GObject *) self, "mount-op");
}


GtkWindow* deja_dup_backend_get_toplevel (DejaDupBackend* self) {
	GtkWindow* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_toplevel;
	return result;
}


static void deja_dup_backend_set_toplevel (DejaDupBackend* self, GtkWindow* value) {
	GtkWindow* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_toplevel = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_toplevel), _tmp0_);
	g_object_notify ((GObject *) self, "toplevel");
}


static void deja_dup_backend_class_init (DejaDupBackendClass * klass) {
	deja_dup_backend_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DejaDupBackendPrivate));
	DEJA_DUP_BACKEND_CLASS (klass)->is_native = deja_dup_backend_real_is_native;
	DEJA_DUP_BACKEND_CLASS (klass)->get_location = deja_dup_backend_real_get_location;
	DEJA_DUP_BACKEND_CLASS (klass)->get_location_pretty = deja_dup_backend_real_get_location_pretty;
	DEJA_DUP_BACKEND_CLASS (klass)->get_envp = deja_dup_backend_real_get_envp;
	DEJA_DUP_BACKEND_CLASS (klass)->add_argv = deja_dup_backend_real_add_argv;
	DEJA_DUP_BACKEND_CLASS (klass)->clone = deja_dup_backend_real_clone;
	G_OBJECT_CLASS (klass)->get_property = deja_dup_backend_get_property;
	G_OBJECT_CLASS (klass)->set_property = deja_dup_backend_set_property;
	G_OBJECT_CLASS (klass)->finalize = deja_dup_backend_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEJA_DUP_BACKEND_MOUNT_OP, g_param_spec_object ("mount-op", "mount-op", "mount-op", G_TYPE_MOUNT_OPERATION, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEJA_DUP_BACKEND_TOPLEVEL, g_param_spec_object ("toplevel", "toplevel", "toplevel", GTK_TYPE_WINDOW, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_signal_new ("envp_ready", DEJA_DUP_TYPE_BACKEND, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOOLEAN_POINTER_STRING, G_TYPE_NONE, 3, G_TYPE_BOOLEAN, G_TYPE_POINTER, G_TYPE_STRING);
}


static void deja_dup_backend_instance_init (DejaDupBackend * self) {
	self->priv = DEJA_DUP_BACKEND_GET_PRIVATE (self);
}


static void deja_dup_backend_finalize (GObject* obj) {
	DejaDupBackend * self;
	self = DEJA_DUP_BACKEND (obj);
	_g_object_unref0 (self->priv->_mount_op);
	_g_object_unref0 (self->priv->_toplevel);
	G_OBJECT_CLASS (deja_dup_backend_parent_class)->finalize (obj);
}


GType deja_dup_backend_get_type (void) {
	static GType deja_dup_backend_type_id = 0;
	if (deja_dup_backend_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (DejaDupBackendClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) deja_dup_backend_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DejaDupBackend), 0, (GInstanceInitFunc) deja_dup_backend_instance_init, NULL };
		deja_dup_backend_type_id = g_type_register_static (G_TYPE_OBJECT, "DejaDupBackend", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	}
	return deja_dup_backend_type_id;
}


static void deja_dup_backend_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DejaDupBackend * self;
	self = DEJA_DUP_BACKEND (object);
	switch (property_id) {
		case DEJA_DUP_BACKEND_MOUNT_OP:
		g_value_set_object (value, deja_dup_backend_get_mount_op (self));
		break;
		case DEJA_DUP_BACKEND_TOPLEVEL:
		g_value_set_object (value, deja_dup_backend_get_toplevel (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void deja_dup_backend_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DejaDupBackend * self;
	self = DEJA_DUP_BACKEND (object);
	switch (property_id) {
		case DEJA_DUP_BACKEND_MOUNT_OP:
		deja_dup_backend_set_mount_op (self, g_value_get_object (value));
		break;
		case DEJA_DUP_BACKEND_TOPLEVEL:
		deja_dup_backend_set_toplevel (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}



static void g_cclosure_user_marshal_VOID__BOOLEAN_POINTER_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__BOOLEAN_POINTER_STRING) (gpointer data1, gboolean arg_1, gpointer arg_2, const char* arg_3, gpointer data2);
	register GMarshalFunc_VOID__BOOLEAN_POINTER_STRING callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__BOOLEAN_POINTER_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_boolean (param_values + 1), g_value_get_pointer (param_values + 2), g_value_get_string (param_values + 3), data2);
}



